﻿' -----------------------------------------------------------------------------------------
'
' UltraMain.vb                                                      Ulrich Müller  24.05.08
'                                                                   PCS1700 VB 2005 Express
' Radarturm unter Nutzung des Ultraschallsensors
' Basis ist die Assembly FishFace2005.DLL
'
' -----------------------------------------------------------------------------------------

Option Explicit On
Option Strict Off
Imports FishFace40

Public Class UltraRadarVB

  Const mTurm As Integer = CType(Out.M1, Integer)
  Const iTurm As Integer = mTurm - 1
  Const mSensor As Integer = CType(Out.M2, Integer)
  Const iSensor As Integer = mSensor - 1
  Const dSensor As Inp = Inp.D1
  Const incTurm As Integer = 30
  Const disNah As Integer = 15
  Const disMittel As Integer = 75

  Dim MotList(,) As Integer = {{mTurm, 180}, {mSensor, 99}}
  Dim WithEvents ft As New FishRobot(MotList)
  Dim rs As Graphics
  Dim Farbe As SolidBrush

  Private Sub Action()
    rs = picAnzeige.CreateGraphics()
    rs.Clear(Color.Black)
    Do
      lblStatus.Text = "Home"
      ft.MoveHome()
      Do While ft.MotCntl(iTurm).actPos < ft.MotCntl(iTurm).maxPos And Not ft.Finish()
        lblStatus.Text = "Scan : Abwärts"
        ft.MoveTo(ft.MotCntl(iTurm).actPos, ft.MotCntl(iSensor).maxPos)
        lblStatus.Text = "Turm : Fahren nach rechts"
        ft.MoveDelta(incTurm)
        lblStatus.Text = "Scan : Aufwärts"
        ft.MoveTo(ft.MotCntl(iTurm).actPos, 0)
        lblStatus.Text = "Turm : Fahren nach rechts"
        ft.MoveDelta(incTurm)
      Loop
      Do While ft.MotCntl(iTurm).actPos > 0 And Not ft.Finish()
        lblStatus.Text = "Scan : Abwärts"
        ft.MoveTo(ft.MotCntl(iTurm).actPos, ft.MotCntl(iSensor).maxPos)
        lblStatus.Text = "Turm : Fahren nach links"
        ft.MoveDelta(-incTurm)
        lblStatus.Text = "Scan : Aufwärts"
        ft.MoveTo(ft.MotCntl(iTurm).actPos, 0)
        lblStatus.Text = "Turm : Fahren nach links"
        ft.MoveDelta(-incTurm)
      Loop
    Loop Until ft.Finish()
  End Sub

#Region "--- ProgramControl ---"
  Private Sub cmdAction_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) _
  Handles cmdAction.Click
    Try
      ft.OpenInterface(IFTypen.ftROBO_first_USB, 0, Distance.UltraSonic)
      cmdAction.Enabled = False
      cmdEnde.Text = "&HALT"
      lblStatus.Text = "--- Bei der Arbeit ---"

      Action()

      ft.ClearMotors()
    Catch ex As FishFaceException
      MsgBox(ex.Message)
    Finally
      ft.CloseInterface()
      cmdAction.Enabled = True
      cmdEnde.Text = "&ENDE"
      lblStatus.Text = "--- Auf ein Neues ---"
      cmdEnde.Focus()
    End Try

  End Sub

  Private Sub cmdEnde_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdEnde.Click
    ' --- Programmende nur, wenn Action nicht läuft ---
    If cmdEnde.Text = "&HALT" Then ft.NotHalt = True Else Me.Close()
  End Sub

  Private Sub frmFormClosing(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles MyBase.FormClosing
    ' --- Wenn Action läuft, wird ein Programmabbruch über (x) unterbunden ---
    If cmdEnde.Text = "&HALT" Then e.Cancel = True
  End Sub

#End Region

  Private Sub ft_PositionChange(ByVal sender As Object, ByVal ActPositions() As Integer) Handles ft.PositionChange
    If (ActPositions(iTurm) Mod incTurm) > 0 Then Return
    Dim Pos As String = "Position : "
    Pos &= ft.MotCntl(iTurm).actPos.ToString("000") & " - "
    Pos &= ft.MotCntl(iSensor).actPos.ToString("000")

    Dim dis As Integer = ft.GetDistance(dSensor)
    lblPosition.Text = Pos & "   Wert : " & dis.ToString()
    If ActPositions.Length = 2 Then
      If dis < disNah Then
        Farbe = New SolidBrush(Color.Red)
      ElseIf dis < disMittel Then
        Farbe = New SolidBrush(Color.Yellow)
      Else
        Farbe = New SolidBrush(Color.Green)
      End If
      rs.FillRectangle(Farbe, ActPositions(iTurm) * 2, ActPositions(iSensor) * 2, 50, 4)
    End If
  End Sub
End Class
